CREATE TABLE IF NOT EXISTS `DiscussDiscuss` ( 
`Id` int(11) NOT NULL AUTO_INCREMENT, 
`Type` INT  NULL ,
`UserId` INT  NULL ,
`ReseauId` INT  NULL ,
`DateCreated` DATE  NULL ,
`Title` TEXT  NULL ,
`Description` TEXT  NULL ,
`Status` INT  NULL ,
`DateClotured` DATE  NULL ,
PRIMARY KEY (`Id`),
CONSTRAINT `ee_user_DiscussDiscuss` FOREIGN KEY (`UserId`) REFERENCES `ee_user`(`Id`)
) ENGINE=InnoDB  DEFAULT CHARACTER SET `utf8`; 

CREATE TABLE IF NOT EXISTS `DiscussUser` ( 
`Id` int(11) NOT NULL AUTO_INCREMENT, 
`DiscussId` INT  NULL ,
`UserId` INT  NULL ,
`Status` INT  NULL ,
PRIMARY KEY (`Id`),
CONSTRAINT `ee_user_DiscussUser` FOREIGN KEY (`UserId`) REFERENCES `ee_user`(`Id`)
) ENGINE=InnoDB  DEFAULT CHARACTER SET `utf8`; 

CREATE TABLE IF NOT EXISTS `DiscussMessage` ( 
`Id` int(11) NOT NULL AUTO_INCREMENT, 
`Type` INT  NULL ,
`UserId` INT  NULL ,
`Message` TEXT  NULL ,
`DateCreated` DATE  NULL ,
`DiscussId` INT  NULL ,
PRIMARY KEY (`Id`),
CONSTRAINT `ee_user_DiscussMessage` FOREIGN KEY (`UserId`) REFERENCES `ee_user`(`Id`),
CONSTRAINT `DiscussDiscuss_DiscussMessage` FOREIGN KEY (`DiscussId`) REFERENCES `DiscussDiscuss`(`Id`)
) ENGINE=InnoDB  DEFAULT CHARACTER SET `utf8`; 

CREATE TABLE IF NOT EXISTS `DiscussComment` ( 
`Id` int(11) NOT NULL AUTO_INCREMENT, 
`UserId` INT  NULL ,
`Message` TEXT  NULL ,
`DateCreated` DATE  NULL ,
`MessageId` INT  NULL ,
PRIMARY KEY (`Id`),
CONSTRAINT `DiscussMessage_DiscussComment` FOREIGN KEY (`MessageId`) REFERENCES `DiscussMessage`(`Id`),
CONSTRAINT `ee_user_DiscussComment` FOREIGN KEY (`UserId`) REFERENCES `ee_user`(`Id`)
) ENGINE=InnoDB  DEFAULT CHARACTER SET `utf8`; 

CREATE TABLE IF NOT EXISTS `DiscussLike` ( 
`Id` int(11) NOT NULL AUTO_INCREMENT, 
`UserId` INT  NULL ,
`DateCreated` DATE  NULL ,
`AppName` VARCHAR(200)  NULL ,
`AppId` INT  NULL ,
`EntityName` VARCHAR(200)  NULL ,
`EntityId` INT  NULL ,
PRIMARY KEY (`Id`),
CONSTRAINT `ee_user_DiscussLike` FOREIGN KEY (`UserId`) REFERENCES `ee_user`(`Id`)
) ENGINE=InnoDB  DEFAULT CHARACTER SET `utf8`; 

CREATE TABLE IF NOT EXISTS `DiscussFollow` ( 
`Id` int(11) NOT NULL AUTO_INCREMENT, 
`DiscussId` INT  NULL ,
`UserId` INT  NULL ,
PRIMARY KEY (`Id`),
CONSTRAINT `ee_user_DiscussFollow` FOREIGN KEY (`UserId`) REFERENCES `ee_user`(`Id`),
CONSTRAINT `DiscussDiscuss_DiscussFollow` FOREIGN KEY (`DiscussId`) REFERENCES `DiscussDiscuss`(`Id`)
) ENGINE=InnoDB  DEFAULT CHARACTER SET `utf8`; 